# encoding: UTF-8

module Minireq
  module Core

    module Excerpt
      LEXCERPT  = '{{'.freeze
      REXCERPT  = '}}'.freeze

      EXCERPT_REGX = /(\w*):[ ]*(.*)$/ # /(\w*):[ ]*(\w*)/
      # EXCERPT_REGX = /(\w*):[ ]*([\w\.]*)/ # /(\w*):[ ]*(\w*)/

      def hash_to_excerpt(hash)
        s = ''
        s << LEXCERPT + "\n"
        hash.each_pair { |k, v| s << "#{k}: #{v}\n" }
        s << REXCERPT + "\n"
        s
      end

      def excerpt_to_hash(text)
        h = {}
        text.each_line do |line|
          line.strip!
          line.scrub!
          next if line.empty?
          next if line.start_with?(LEXCERPT) || line.start_with?(REXCERPT)
          pair = EXCERPT_REGX.match(line)
          key = pair[1]
          val = pair[2]
          h[key.to_sym] = val
        end
        h
      end
    end
  end
end
