module Minireq
  module Data

    module DslFileMixin

      # Trace DSL skip function
      # @param obj[Object, Array<Object>] to skip
      def skip(obj, desc = '')
        obj = [obj] unless obj.is_a? Array
        obj.each { |o| @skips[o] = desc }
      end

      def objects
        @items.keys.concat(@skips.keys)
      end

      def include?(obj)
        @items.include?(obj) || @skips.include?(obj)
      end

      def save(file_name)
        File.open(file_name, 'w') do |f|
          @skips.each { |k, v| f.write skip_dsl(k) }
          f.write "\n"
          @items.each { |k, v| f.write item_dsl(k) }
        end
      end

      def dsl_func(obj)
      end

      def item_dsl(obj)
      end

      def skip_dsl(obj)
        "skip '#{obj}', '#{@skips[obj]}'\n"
      end
    end
  end
end
