# encoding: UTF-8
require_relative 'dsl_file_mixin'
require_relative '../dsl'

module Minireq
  module Data

    class FpaDslFile < Minireq::Dsl::FpaDSL
      include DslFileMixin

      attr_reader :skips

      def initialize
        @skips = {}
        super
      end

      def load(file_name)
        estimate { eval File.read(file_name) }
      end

      def dsl_func(req)
        if req.body.empty?
          skip(req.id, 'empty requirement body')
        else
          ILF(req.id, det: 1, ret: 1)
        end
      end

      def item_dsl(obj)
        params = @items[obj]
        ps = ""
        params.each {|k, v| ps << ", #{k}: #{v}" unless k.eql?(:fun)}
        "#{params[:fun]} '#{obj}'#{ps}\n"
      end

    end

  end
end

# include Minireq::Data
# fpa = FpaDslFile.new
# fpa.estimate do
#   ILF :id_1, det: 9, ret: 1
#   EIF :id_2, det: 8, ret: 2
#   puts item_dsl(:id_1)
#   puts item_dsl(:id_2)
# end
