# encoding: UTF-8
require_relative 'dsl_file_mixin'
require_relative '../dsl'

module Minireq
  module Data

    class PertDslFile < Minireq::Dsl::PertDSL
      include DslFileMixin

      attr_reader :skips

      def initialize
        @skips = {}
        super
      end

      def load(file_name)
        estimate { eval File.read(file_name) }
      end

      def dsl_func(req)
        if req.body.empty?
          skip(req.id, 'empty requirement body')
        else
          pert(req.id, o: 1, m: 2, p: 3)
        end
      end

      def item_dsl(obj)
        p = @items[obj]
        "pert '#{obj}', o: #{p[:o]}, m: #{p[:m]}, p: #{p[:p]}\n"
      end
    end

  end
end
