# encoding: UTF-8
require_relative 'dsl_file_mixin'
require_relative '../dsl'

module Minireq
  module Data

    class TraceDslFile < Minireq::Dsl::TraceDSL
      include DslFileMixin

      attr_reader :skips

      def initialize
        @skips = {}
        super
      end

      def load(file_name)
        trace { eval File.read(file_name) }
      end

      def dsl_func(req)
        if req.body.empty?
          skip(req.id, 'empty requirement body')
        else
          from(req.id, :key, 'value')
        end
      end

      def item_dsl(obj)
        result = ''
        traces = @items[obj]
        return 'nil' unless traces
        traces.each do |k, v|
          if v.is_a? Array
            value = "[" + v.map {|i| "'#{i}'"}.join(', ') + "]"
          else
            value = v
          end
          result << "from '#{obj}', :#{k}, #{value}\n"
        end
        result
      end
    end

  end
end

# include Minireq::Data
# tracer = TraceStore.new('demo.dsl')
# tracer.trace do
#   skip :a
#   skip :b
#   from :c, :source, [:d, :e]
#   from :d, :source, [:c, :e]
#   save
#   load
#   load
#   load
#   save
# end
