# User stories

@@topic As a requirement writer, at any time, through text editor or CLI, I want to write requirements in different Markdown structured files in requirements repository folder.

  @@story As a requirements writer, at time working on requirement file, through text editor, I want to add links between requirements (requirement parent and simple requirements links) which are located in different requirements files.

  @@story As a requirements writer, at any time, through CLI, I want to merge requirements written in different files into single consistent document, because I need requirements in single document, but I have few files with requirements.

  @@story As a requirement writer, at any time, through Git, I need to manage to versions of requirements.

@@topic As a requirements writer, at particular time period, through Web, I want to give access to certain version of requirements document to another team members, because requirements must be checked by all team members.

  @@story As a project team member, at any time, through CLI, I need to add users authentication information to access to Web application, because all team members must have access to requirements.

  @@story As a project team member, at any time during certain period of checking requirements, I need to have ability to comment any requirement.

  @@story As a requirements writer, at any time during certain period of checking requirements, I need to have ability to get all comments for requirements written by all project team members.

@@topic As a PM, when requirements elicitation phase completed and requirements are ready, through CLI, I need to ability to manage requirement priorities through specialized Priorities DSL file.

  @@story As a PM, when requirements elicitation phase completed and requirements are ready, through CLI, I need to be able to create priority DSL file based on requirements repository, because priorities assessment is an important part of my work.

  @@story As a PM, when requirements elicitation phase completed and requirements are ready, through CLI, I need to be able to update priority DSL file from requirements repository, because I need be sure that Priorities DSL file is up to date.

  @@story As a PM, when requirements elicitation phase completed and requirements are ready, through CLI, I need to be able to check priority DSL file for errors like requirements duplicates, missed and wrong requirements, because I need be sure that Priorities DSL file is consistent.

@@topic As a PM, when requirements elicitation phase completed and requirements are ready, through CLI, I need to ability to manage requirement assessment by PERT method.

  @@story As a PM, when requirements elicitation phase completed and requirements are ready, through CLI, I need to be able to create PERT Estimation DSL File, because I need it to calculate project efforts.

  @@story As a PM, when requirements elicitation phase completed and requirements are ready, through CLI, I need to be able to update PERT Estimation DSL File, because I need be sure that PERT Estimation DSL File is up to date.

  @@story As a PM, when requirements elicitation phase completed and requirements are ready, through CLI, I need to be able to check PERT Estimation DSL File for requirements duplicates, missed and wrong requirements, because I need be sure that PERT Estimation DSL file is consistent.

  @@story As a PM, at any time when PERT Estimation DSL File created, through CLI, I need to be able to calculate project efforts by PERT Estimation DSL File, because I need calculate project efforts.

@@topic As a PM, when requirements elicitation phase completed and requirements are ready, through CLI, I need to ability to manage requirement assessment by FPA method.

  @@story As a PM, when requirements elicitation phase completed and requirements are ready, through CLI, I need to be able to create FPA Estimation DSL File, because I need it to calculate project efforts.

  @@story As a PM, when requirements elicitation phase completed and requirements are ready, through CLI, I need to be able to update FPA Estimation DSL File, because I need be sure that PERT Estimation DSL File is up to date.

  @@story As a PM, when requirements elicitation phase completed and requirements are ready, through CLI, I need to be able to check FPA Estimation DSL File for requirements duplicates, missed and wrong requirements, because I need be sure that PERT Estimation DSL file is consistent.

  @@story As a PM, at any time when FPA Estimation DSL File created, through CLI, I need to be able to calculate project efforts by FPA Estimation DSL File, because I need calculate project efforts.

@@topic As a project team member, during my usual working time, through CLI, I need to be able to manage to traces between requirements and any other project artifacts (tests, source code, guides, etc.).

  @@story As a project team member, during my usual working time, through CLI, I need to be able to create Traces DSL File, because I need it to manage to traces between projects artifacts.

  @@story As a project team member, during my usual working time, through CLI, I need to be able to update Traces DSL File, because I need be sure that Traces DSL File is up to date.

  @@story As a PM, project team member, during my usual working time, through CLI, I need to be able to check Traces DSL File for requirements duplicates, missed and wrong requirements, because I need be sure that Traces DSL file is consistent.

  @@story As a project team member, during my usual working time, through CLI, I need to be able to ask Traces repository different questions like "which requirements do not have certain traces, source code or tests", because I need to manage requirement traces.
