# [core.doc] Document
{{
parent: core
}}

The System shall provide the `Document` entity.

## [core.doc.data] Document data

The System shall provide the following data elements for `Document` entity:

Name  | Type          | M | Description
:---- | ------------- | - | :----------------------------------
items | Requirement[] | N | Array of top requirement entities

## [core.doc.load] Requirements loading

The System shall provide the ability to load all requirements files in an a relevant directory of file system into `Document` entity.
TBD: move dierectory as function parameter

## [core.doc.load.hrch] Hierarchy building

When all files are loaded, the System shall build the right requirements hierarchy through the `parent` attribute (see [[core.req.file.attr.sys]] and [[core.req.file.struct]]).

## [core.doc.load.sort] Sort child requirements

When all files are loaded, if any requirement has a `child_order` system attribute, the System shall sort its child requirements according to the attribute value.

## [core.doc.chk] Check requirements

The System shall provide the ability to check loaded requirements for the following errors:
* duplicates of requirement ids among requirement files;
* wrong links to other requirements in requirement body.

### [core.doc.chk.dup] Duplicate id
TBD: provide description

### [core.doc.chk.lnk] Wrong links
TBD: provide description
