# [dsl.trace] Trace DSL
{{
parent: dsl
}}

The System shall provide `Trace DSL` for tracing requirements to other project artifacts like tests, source code, different guides, etc.

An example of `Tracing DSL` is as follows..

```ruby
skip 'func', 'top level topic'
skip 'nonf', 'top level topic'

from 'id.1', :source, 'src/id.1.rb'
from 'id.1', :test,   'src/id.1.spec.rb'

from 'id.2', :source, ['lib/id.1.rb', 'lib/id.1.helper.rb']
from 'id.2', :test,   ['spec/id.1.spec.rb']
from 'id.2', :guide,  ['doc/user-guide', 'doc/admin-guide']
```

## [dsl.trace.skip] Skip

The System shall provide `Tracing DSL` function `skip`. This function just places requirement id to skipped area.

The `skip` function must accept the following parameters.

Parameter   | Type             | M | Description
:---------- | ---------------- | - | :-----------------
object      | Object, Object[] | Y | Skipped object
description | String           | N | Reason of skipping

## [dsl.trace.from] From

The System shall provide `Tracing DSL` function `from` to add traces to the object.

The `from` function must accept the following parameters.

Parameter     | Type             | M | Description
:------------ | ---------------- | - | :-----------------------------------------------------------
traced object | Object           | Y | traced object (from)
type          | String, Symbol   | Y | Kind of trace from source object to the target object (type)
target object | String, String[] | Y | target object (to)
